#!/bin/bash
#
# File to actually install the software
# copy main prog
#
# Install nvidia-live.sh 
# 
# Copyright (C) 2003 by Fabian Franz <knx-live@fabian-franz.de>
#
# License: GPL, see /usr/share/doc/common-licenses/GPL.
#
# based on work done by Kano, 
# thank you without you this script would not exist.

if [ -z "$(lspci | grep VGA | grep -i nvidia)" ]
then
  abort $"No nVidia graphics adapter could be found."
  return 1
fi

#
# Preparations
#

sudo=/KNOPPIX/usr/bin/sudo
VER=1.0-4363
NVIDIA_DIR=$DESTDIR/nvidia
mkdir -p $NVIDIA_DIR/kernel


#
# NVIDIA - Kernel module
#

update_status $"Compiling kernel module ..."

cd NVIDIA_kernel-$VER

if test "`grep 2.95 /proc/version`" -a -e /usr/bin/gcc-2.95; then
 make CC=/usr/bin/gcc-2.95 1>&2
elif test "`grep 3.2 /proc/version`" -a -e /usr/bin/gcc-3.2; then
 make CC=/usr/bin/gcc-3.2
elif test "`grep 3.3 /proc/version`" -a -e /usr/bin/gcc-3.3; then
 make CC=/usr/bin/gcc-3.3
else
 make IGNORE_CC_MISMATCH=1
fi

# copy it to a safe place, we load it later

cp nvidia.o $NVIDIA_DIR/kernel/nvidia-`uname -r`.o
$sudo ./makedevices.sh
cd ..

# 
# NVIDIA GLX - module
#

cd NVIDIA_GLX-$VER

#
# Live-CD hack :-)
#

INSTDIR=$(pwd)
mkdir -p $NVIDIA_DIR/usr

[ -L /usr.old ] && ( $sudo rm -f /usr; sudo mv /usr.old /usr )

[ ! -L /usr.new ] && $sudo ln -s $NVIDIA_DIR/usr/ /usr.new
rm -rf /usr.new/*

for i in $(make -n install | grep rm | awk '{ print $3 }')
do 
  case $i in *'*') continue ;; esac
  new=$(echo $i | sed 's,/usr,/usr.new,g')
  mkdir -p $(dirname $new)
  touch $new 
done

for i in $(find usr -type d | grep -v "bin")
do
  new=$(echo $i | sed 's,usr,/usr.new,g')
  mkdir -p $new
done

#recurs_linking()
#{
#  echo $"Linking files in $1 ..."
#  cd $1
#  for i in *
#  do
#    ln -s $3$1/$i $2/$i 2>/dev/null
#    [ ! -L $2/$i -a -d $2/$i ] && recurs_linking $1/$i $2/$i $3
#  done
#}

echo $"Creating link structure ..."
#recurs_linking "/usr" "/usr.new" "/KNOPPIX"
cd /usr.new
for i in $(find . -type "d")
do 
  (cd $i; [ -d /KNOPPIX/usr${i/./} ] && ln -s /KNOPPIX/usr${i/./}/* . 2>/dev/null)
done
echo $"Replacing /usr ..."
$sudo mv /usr /usr.old
$sudo mv /usr.new /usr

echo $"Installing nvidia-glx ..."
cd $INSTDIR

$sudo make install
cd ..

#
# replace XF86Config, [load module and restart X (in exit.sh) ]
#

update_status $"Replacing XF86Config-4"

if ! test -e /etc/X11/XF86Config-4.1st; then
 $sudo cp /etc/X11/XF86Config-4 /etc/X11/XF86Config-4.1st
fi

perl -p -e 's/^[\s]*Load\s*"GLcore"/#\tLoad  "GLcore"/;
            s/^[\s]*Load\s*"dri"/#\tLoad  "dri"/;
            s/^[\s]*#*[\s]*Load\s*"glx"/\tLoad  "glx"/;
            s/^[\s]*Driver\s*"nv"/\tDriver      "nvidia"/g;
            s/^[\s]*Driver\s*"fbdev"/\tDriver      "nvidia"/g;
            s/^[\s]*Driver\s*"vesa"/\tDriver      "nvidia"/g' \
            < /etc/X11/XF86Config-4.1st > $TMPDIR/XF86Config-4

$sudo cp $TMPDIR/XF86Config-4 /etc/X11/XF86Config-4

$sudo ldconfig
